
# Interpolation examples

# Multiple ways to interpolate.

# Simple-interface:

import scipy.interpolate as si
from numpy import *

import pylab 

t = r_[0:1:10j]
y = sin(2*pi*3*t) + sin(2*pi*1.5*t)

tt = r_[0:1:100j]
yy_exact = sin(2*pi*3*tt) + sin(2*pi*1.5*tt)

f1 = si.interp1d(t,y,kind=1)
f2 = si.interp1d(t,y,kind=2)
f3 = si.interp1d(t,y,kind=3)
f4 = si.interp1d(t,y,kind=4)
f5 = si.interp1d(t,y,kind=5)

yy1 = f1(tt)
yy2 = f2(tt)
yy3 = f3(tt)
yy4 = f4(tt)
yy5 = f5(tt)

pylab.figure(1)
pylab.clf()
pylab.plot(t, y,'o')
pylab.plot(tt,yy_exact)
pylab.plot(tt,yy1)
pylab.plot(tt,yy2)
pylab.plot(tt,yy3)
pylab.plot(tt,yy4)
pylab.plot(tt,yy5)
pylab.legend(['Samples', 'Exact','Linear','Quadratic','Cubic','Quartic','Quintic'],loc=3)




