from numpy import *
import scipy.ndimage as sn
import scipy.misc as misc
import glob
import os
import pylab

direc = 'FallWinter2003'

files = glob.glob(os.path.join(direc,'*.jpg'))

im = misc.imread(files[0])

thresh = im[:,:,0] > 130

pylab.figure(1)
pylab.clf()
pylab.imshow(thresh)
pylab.title('Thresholded Red Channel')

structure = ones((7,7))
erode = sn.binary_erosion(thresh, structure)
pylab.figure(2)
pylab.imshow(erode)
pylab.title('Eroded')

dilate = sn.binary_dilation(thresh, structure)
pylab.figure(3)
pylab.imshow(dilate)
pylab.title('Dilated')

opening = sn.binary_opening(thresh, structure, iterations=2)
pylab.figure(4)
pylab.imshow(opening)
pylab.title('Opened')
