import scipy.io.wavfile as siw
import scipy.signal as ss
import pylab
from numpy import *

# Read in original song
rate, data = siw.read('Songs/26 Cuckoo.wav')
rate2 = rate/2.0
# Design low-pass filter
N,Wn = ss.buttord(4000/rate2,7000/rate2,5,30)
b,a = ss.butter(N,Wn)

# Plot filter
w,h = ss.freqz(b,a,512)
pylab.figure(1)
pylab.clf()
pylab.subplot(211)
pylab.plot(w/pi*rate2,abs(h))
pylab.ylabel('Magnitude')
pylab.subplot(212)
pylab.plot(w/pi*rate2,unwrap(angle(h)))
pylab.xlabel('frequency (Hz')
pylab.ylabel('Angle')

# Filter data and down-sample
out = ss.lfilter(b,a,data,axis=0)[::4,:]
OUT = fft.fft(out,axis=0)
freqs = fft.fftfreq(out.shape[0],d=4.0/rate)
pylab.figure(2)
pylab.clf()
pylab.subplot(212)
pylab.plot(freqs, abs(OUT[:,0]))
pylab.xlim(-10000,10000)
DATA = fft.fft(data,axis=0)
freqorig = fft.fftfreq(data.shape[0],d=1.0/rate)
pylab.subplot(211)
pylab.plot(freqorig,abs(DATA[:,0]))
pylab.xlim(-10000,10000)

# Write out filtered result with new sample rate.
siw.write('temp.wav',rate/4,out.astype(int16))


# Make an echo of 0.35 sec
# There are obviously faster ways to do this....
delay = 0.35
amp = 0.35

dsamp = int(delay * rate/4)
h = zeros(dsamp,float)
h[0] = 1
h[-1] = amp
out2 = ss.lfilter(h,1,out,axis=0).astype(int16)

# Write out the new sound file.
siw.write('temp2.wav', rate/4, out2)
