import os
# microns
deltax = 25.4
deltay = 25.4
tip_size = 100.0
height = 50.0
direc = "data"
from scipy import *
from numpy import *
NewAxis = newaxis
def recon(image,alpha,h,a=None):
    N,M = image.shape
    dx,dy = 25.4,25.4  # microns
    f1 = fft.fftfreq(N,dx)[:,NewAxis]
    f2 = fft.fftfreq(M,dy)[NewAxis,:]
    w = 2*pi*sqrt(f1**2 + f2**2)
    IMAGE = fft.fft2(image)
    if a is None:
        KINV = exp(-w*h)/(exp(-2*w*h)+alpha)*(alpha+1)        
    else:       
        J1 = special.j1(w*a)
        KINV = exp(-w*h)*J1 / (exp(-2*w*h)*J1*J1 + alpha*w**2)
        KINV = KINV * (a*a+4*alpha)/(2*a)
        KINV[0,0] = 1

    REC = KINV*IMAGE
    rec = fft.ifft2(REC)
    return real(rec)
    # Tikhonov reconstruction



# First flower
#filename = "syringe_100um_5Vpp_1kHz.txt"
#filename = "Narrow_leaf_100um_2.5Vpp_1kHz_syringetip2.txt"
#filename = "Purple_Flower_100um_5Vpp_1kHz_syringetip.txt"
#im = imread('syringe.bmp')
filename = "flower_100um_5Vpp_1kHz_syringetip.txt"
#im = misc.imread(direc+'flower_100um_5Vpp_1kHz_syringetip.bmp')
a = io.read_array(os.path.join(direc,filename))
a = a[:-181]
a.shape = (80,180)

b= a*0.0
b[::2,:] = a[::2,:]
b[1::2,:] = a[1::2,::-1]
# adjust
#b[1::2,1:] = b[1::2,:-1]
I = signal.medfilt2d(b)
Iplot = I[23:,:][::-1,:].copy()
# clean up a bit...
s1 = slice(145,180)
fixreg = (slice(26,53,2),s1)
fixreg1 = (slice(25,52,2),s1)
fixreg2 = (slice(27,54,2),s1)
Iplot[fixreg] = (Iplot[fixreg1] + Iplot[fixreg2])/2.0
s1 = slice(159,180)
fixreg = (slice(1,26,2),s1)
fixreg1 = (slice(0,25,2),s1)
fixreg2 = (slice(2,27,2),s1)
Iplot[fixreg] = (Iplot[fixreg1] + Iplot[fixreg2])/2.0
Iplot[14,0] = Iplot[14,1]
Iplot[17,0] = Iplot[17,1]
Iplot[15,:28] = Iplot[14,:28]*2.0/3.0 + Iplot[17,:28]*1.0/3.0
Iplot[16,:28] = Iplot[14,:28]*1.0/3.0 + Iplot[17,:28]*2.0/3.0
Iplot[0,0] = Iplot[0,1]
Iplot[0,-1] = Iplot[0,-2]
Iplot[1,-1] = Iplot[1,-2]


#make a colorbar
#cbar = arange(256,typecode='d')[NewAxis,:]*ones(15)[:,NewAxis]
 
import pylab
pylab.figure(1)
pylab.clf()
pylab.pcolor(recon(Iplot,0.01,35,None), vmin=-0.01, vmax=0.23, cmap=pylab.cm.gray,shading='flat')
pylab.title('Reconstructed')
pylab.axis('equal')
pylab.figure(2)
pylab.clf()
pylab.pcolor(recon(Iplot,0.01,0,None),vmin=-0.01,vmax=0.23, cmap=pylab.cm.gray,shading='flat')  
pylab.title('Original')
pylab.axis('equal')
#xplt.window(0)
#xplt.palette('gray.gp')
#xplt.matview(recon(Iplot,0.01,35,None),cmax=0.23,cmin=-0.01,color=None)
#xplt.eps('flower_recon_0.01_35')
#xplt.window(1)
#xplt.palette('gray.gp')
#xplt.matview(recon(Iplot,0.01,0,None),cmax=0.23,cmin=-0.01,color=None)
#xplt.eps('flower_raw')


# second flower
#filename = "syringe_100um_5Vpp_1kHz.txt"
#filename = "Narrow_leaf_100um_2.5Vpp_1kHz_syringetip2.txt"
filename = "Purple_Flower_100um_5Vpp_1kHz_syringetip.txt"
#im = misc.imread(direc+'Purple_Flower.bmp')
a = io.read_array(os.path.join(direc,filename))
a = a[:-201]
a.shape = (100,200)

b= a*0.0
b[::2,:] = a[::2,:]
b[1::2,:] = a[1::2,::-1]
# adjust
#b[1::2,1:] = b[1::2,:-1]
I = signal.medfilt2d(b)
pylab.figure(3)
pylab.clf()
pylab.pcolor(recon(I,0.01,35,None)[5:-2,10:-50],vmax=0.23,vmin=-0.07,shading='flat',cmap=pylab.cm.gray)
pylab.title('Reconsructed')
pylab.axis('equal')
pylab.figure(4)
pylab.clf()
pylab.pcolor(recon(I,0.01,0,None)[5:-2,10:-50],vmax=0.23,vmin=-0.07,shading='flat',cmap=pylab.cm.gray)
pylab.title('Original')
pylab.axis('equal')
#xplt.window(0)
#xplt.palette('gray.gp')
#xplt.matview(recon(I,0.01,35,None)[5:-2,10:-50],cmax=0.23,cmin=-0.07,color=None)
#xplt.eps('purple_flower_recon_0.01_35')
#xplt.window(1)
#xplt.palette('gray.gp')
#xplt.matview(recon(I,0.01,0,None)[5:-2,10:-50],cmax=0.23,cmin=-0.07,color=None)
#xplt.eps('purple_flower_raw')



# plant leaf
##filename = "Narrow_leaf_100um_2.5Vpp_1kHz_syringetip2.txt"
##im = imread(direc+'Narrow_leaf2.bmp')
##a = io.read_array(direc+filename)
##a = a[:-81]
##a.shape = (60,80)
##b= a*0.0
##b[::2,:] = a[::2,:]
##b[1::2,:] = a[1::2,::-1]
### adjust
##b[1::2,1:] = b[1::2,:-1]
##I = signal.medfilt2d(b)
##xplt.window(0)
##xplt.palette('gray.gp')
##xplt.matview(recon(I,0.01,35,None),cmax=0.04,cmin=0.01)
###xplt.eps('narrow_leaf_recon_0.01_35')
##xplt.window(1)
##xplt.palette('gray.gp')
##xplt.matview(recon(I,0.01,0,None),cmax=0.04,cmin=0.01)
###xplt.eps('narrow_leaf_raw')
