from numpy import *

_notes = {'C': 60,
          'D': 62,
          'E': 64,
          'F': 65,
          'G': 67,
          'A': 69,
          'B': 71}

def midi2freq(p):
    return 440*(2**((p-69)/12.))
# Write a file that plays notes
          
def create_wave(srate, notes, tempo):
    """srate : sample rate
       notes : a list of (midi-note, type),
       tempo : the tempo to play at (in quarter-notes per minute)

       type is 1.0/(note-kind).  whole-note == 1, half-note = 2, quarter-note=4,
    """
    tempo = tempo/60.0 # quarter-notes per second
    duration = 4.0/tempo # seconds per whole-note
    waveform = []
    for midi, type in notes:
        if isinstance(midi, str):
            midi = _notes[midi]
        freq = midi2freq(midi)
        time = duration/type
        t = r_[0:time:1.0/srate]
        this_note = sin(2*pi*freq*t)
        if waveform == []:
            waveform = this_note
        else:
            waveform = concatenate((waveform, this_note))
    return waveform
        
